/*
  Name: Button Class
  Copyright: 203a.com
  Author: Huang Guan
  Date: 11-11-05 16:07
  Description: Used for Collect Diamonds
*/

#include <allegro.h>
#include <string.h>
class Button
{
      private:
      int x;
      int y;
      int w;
      int h;
      char text[256];
      bool enabled;
      bool visible;
      int fontcolor;
      int lightcolor;
      int bgcolor;
      bool value;
      bool mousedown;
      
      bool insite(){
           if (mouse_x>=x&&mouse_x<=x+w&&mouse_y>=y&&mouse_y<y+h&&enabled)
           return true;
           return false;
      };
      public:
      Button(){
      };
      ~Button(){};
      void Create(const char *caption,int x0,int y0,int h0,int w0)
      {
               x=y=0;
               w=h=32;
               strcpy(text,"Button");
               visible=enabled=true;
               fontcolor=makecol(0,0,0);
               bgcolor=makecol(192,192,192);
               value=false;
               mousedown=false;
               lightcolor=makecol(227,227,227);
               
           strcpy(text,caption);
           x=x0;
           y=y0;
           h=h0;
           w=w0;
      };
      void Move(int x0,int y0,int w0,int h0)
      {
           x=x0;
           y=y0;
           w=w0;
           h=h0;
      };
      void Draw(BITMAP *o)
      {
           if(!visible)return;
           //drawback
           if (insite()){
           rectfill(o,x,y,x+w,y+h,lightcolor);
           }else
           rectfill(o,x,y,x+w,y+h,bgcolor);
           
           //write text
           textout_centre_ex(o,font,text,x+w/2,y+8,fontcolor,-1);        
      };
      void Flash()
      {
           if(!visible||!enabled)return;
           if(insite())
           {
               if(mouse_b&1)
               {            
                           mousedown=true;
                           }
               else{
                    if(mousedown){
                                  mousedown=false;
                                  value=true;
                    }
               }
           }   
      };
      void Visible(bool b){
           visible=b;
      };
      void Enable(bool b){
           enabled=b;
      };
      bool Value(){
           bool v=value;
           value=false;
           return v;
      };
};
      
