/*
  Name: Collect Diamonds
  Copyright: 203a.com
  Author: Huang Guan
  Date: 11-11-05 16:07
  Description: 
*/

#include <allegro.h>
#include <string.h>
#include <math.h>
#include <time.h>
#include "button.h"
#include "Sprite.h"
#include "stdio.h"

#define fwUP 0
#define fwRIGHT 1
#define fwDOWN 2
#define fwLEFT 3
#define IND 48
int def_train_speed =1;
int DELAY =30;
int def_train_speed2= 5;
int def_player_speed = 5;
int def_fruit_count = 10;
int COLOR_MODE =32;
int WINDOW_MODE= 2;
int SW = 640;
int SH = 480;

#define random(num)   (rand() % (num))   /*random*/



/***Game Bits ***/
BITMAP *buffer;
BITMAP *bmouse;
BITMAP *blost;

PALLETE pallete;   /*ͼļĵɫ*/
/*** END GAME BIT**/

/*** Game Sprites ***/

Sprite sgreen;
Sprite sblue;
Sprite syellow;
Sprite sred;
Sprite splayer;
Sprite strain;
Sprite sfire;
Sprite sback;
/*** END GMAE SPRITES ***/

/**GAME SOUND**/
SAMPLE *liveup;
SAMPLE *attact;
SAMPLE *seat;

MIDI *backsound;

int pan = 128; /* (pan) λ*/
int pitch = 1000; /*ʱƵ*/

bool showmouse=false;//ʾ 
/**END SOUND**/


/**STRUCTIONS**/
struct POS{
       int x;int y;//꣬
};
struct GAME_UNIT{
       int level;//ؿ
       long score;//
       int fruitmax;//
       int pause;//ͣ 
       int height;
       int width;
       int end;//־ 
       long timer;//ʱ
       int apples;//
       char name[256];
}unit;

struct _PLAYER{
       int live;//hp
       int speed;//ٶ
       int speed2;//ٶ
       int speedmax;//ٶ
       long maxjy;// 
       int fw;//λ
       POS pos;//λ
}player;//

struct _TRAIN{
       int fw;
       POS pos;
       int speed;
       int speed2;//ٶ
}train[4];//4 trains 

struct _fruit{
       POS pos;
       int score;
       int level;//level of score
       int live;//
}*fruit; //

struct _fire{
       int fw;//λ
       int speed;//ٶ
       int live;
       POS pos;//xy
}fire[4];
/**END OF STRUCTIONS**/

/** Buttons **/
Button bstart;
Button bend;
Button bresume;
/** END OF BUTTONS **/

int randx()
{
    int result;
cn:    result=random(unit.width);
    if (result<IND || result>unit.width-IND)goto cn;
    return result;
}
int randy()
{
    int result;
cn:    result=random(unit.height);
    if (result<IND || result>unit.height-IND)goto cn;
    return result;
}
void delay(unsigned long ms)
{
    double start_time = static_cast<double>( clock() ) / CLOCKS_PER_SEC * 1000;    
    while ( static_cast<double>( clock() ) / CLOCKS_PER_SEC * 1000 - start_time < ms );
    
}
void delay2(unsigned long ms)
{
    double start_time = static_cast<double>( clock() ) / CLOCKS_PER_SEC * 1000;    
    while ( static_cast<double>( clock() ) / CLOCKS_PER_SEC * 1000 - start_time < ms ) 
    putpixel(screen,random(SCREEN_W),random(SCREEN_H),makecol(random(256),random(256),random(256)));;
}
/*Ļ*/
void setvideo()
{
    set_color_depth(COLOR_MODE);
    set_gfx_mode(WINDOW_MODE, SW, SH, 0, 0); /*Ļʾģʽ */
    buffer = create_bitmap(SCREEN_W, SCREEN_H); /*˫ͼλ*/
}


void game_load()
{
     //game_initdata();
    play_midi(backsound,1);
	fruit=(_fruit*)malloc(100*sizeof(_fruit));
     FILE *fp=fopen("save.dat","r");
     fread(&unit,sizeof(struct GAME_UNIT),1,fp);
     fread(&player,sizeof(struct _PLAYER),1,fp);
     for(int i=0;i<4;i++){
             fread(&train[i],sizeof(struct _TRAIN),1,fp);
             fread(&fire[i],sizeof(struct _fire),1,fp);
             }
     for(int i=0;i<100;i++){
             fread(&fruit[i],sizeof(struct _fruit),1,fp);
             }
     unit.end=false;
     unit.pause=false;
     fclose(fp);
}
void game_save(){
     if(unit.fruitmax==0)return;
     FILE *fp=fopen("save.dat","w");
     fwrite(&unit,sizeof(struct GAME_UNIT),1,fp);
     fwrite(&player,sizeof(struct _PLAYER),1,fp);
     for(int i=0;i<4;i++){
             fwrite(&train[i],sizeof(struct _TRAIN),1,fp);
             fwrite(&fire[i],sizeof(struct _fire),1,fp);
             }
     for(int i=0;i<100;i++){
             fwrite(&fruit[i],sizeof(struct _fruit),1,fp);
             }
     fclose(fp);
}
     
void game_next(){
   	//New Game
	unit.level++;//first
	//Player
	sback.AutoStep();
	player.speed=0;
	player.speed2=0;
	player.speedmax=def_player_speed;
	player.fw=fwUP;
	player.pos.x=unit.width/2-16;
	player.pos.y=unit.height/2-16;
	//Train
	train[0].fw=fwRIGHT;
	train[0].pos.x=16;
	train[0].pos.y=16;
	train[0].speed=def_train_speed;
	train[0].speed2=def_train_speed2;
	
	train[1].fw=fwLEFT;
	train[1].pos.x=unit.width-16;
	train[1].pos.y=unit.height-16;
	train[1].speed=def_train_speed;
	train[1].speed2=def_train_speed2;
	
	train[2].fw=fwUP;
	train[2].pos.x=16;
	train[2].pos.y=unit.height-16;
	train[2].speed=def_train_speed;
	train[2].speed2=def_train_speed2;
	
	train[3].fw=fwDOWN;
	train[3].pos.x=unit.width-16;
	train[3].pos.y=16;
	train[3].speed=def_train_speed;
	train[3].speed2=def_train_speed2;
	//Fires
	for(int i=0;i<4;i++)
	{
            fire[i].live=0;
    }
	//fruit
	if(unit.fruitmax<99)unit.fruitmax+=2;
	for(int i=0;i<unit.fruitmax;i++)
	{
            fruit[i].level=random(4)+1;
            fruit[i].score=random(fruit[i].level*100);
            fruit[i].pos.x=randx();
            fruit[i].pos.y=randy();
            fruit[i].live=-1;
    }  
}
void game_initdata()
{
	//New Game
	unit.level=0;//first
	unit.score=0;
	unit.end=0;
	unit.pause=0;
	unit.timer=0;
	unit.width=SW;
	unit.height=SH;
	player.live=3;
	player.maxjy=8000;
	strcpy(unit.name,"Collect Diamonds");//Game MAP Name
	unit.fruitmax=def_fruit_count;
	unit.apples=0;
    play_midi(backsound,1);
	fruit=(_fruit*)malloc(100*sizeof(_fruit));
    game_next();
}

void loadfile()
{
     //Load Picture
     
     if((blost=load_bmp("lost.dat",pallete))==NULL)  /*ͼλļ*/
     {allegro_message("Can't open file lost.dat !!!");
      return; 
     }
     if((bmouse=load_bmp("mouse.dat",pallete))==NULL)  /*ͼλļ*/
     {allegro_message("Can't open mouse lost.dat !!!");
      return; 
     }
     
     
     set_palette(pallete);                   /*صɫ*/
     
     //Load WAV
     seat=load_sample("eat.wav");
     attact=load_sample("attact.wav");
     liveup=load_sample("tada.wav");
     backsound=load_midi("town.dat");
     
     sgreen.Create("green",2,32,32);
     sblue.Create("blue",2,32,32);
     syellow.Create("yellow",2,32,32);
     sred.Create("red",2,32,32);
     splayer.Create("player",4,32,32);
     sfire.Create("fire",3,32,32);
     strain.Create("train",3,32,32);
     sback.Create("back",3,640,480);
     
     bstart.Create("Start",320-40,200,24,80);
     bend.Create("End",320-40,230,24,80);
     bresume.Create("Continue",320-40,170,24,80);
}

//*ײ*// 
int hit()
{
    //Hit Furit
    
    //Hit Fire
    
}

//*ʾ*// 
void show_to_screen()
{
    char c[256];
    sprintf(c,"Game Level: %d     Score: %ld     Apples: %ld      Player Lives: %d",unit.level,unit.score,unit.apples,player.live);
    textout_ex(buffer,font,c,10,10,makecol(255,255,255),-1);
    blit(buffer,screen,0,0,0,0,SCREEN_W,SCREEN_H);
    clear_to_color(buffer,makecol(0,128,0));
}

void put_bmp()
{
     //ͼƬ
     //blit(bback,buffer,0,0,0,0,SCREEN_W,SCREEN_H); 
     sback.blt(buffer);
     //Fruit
     for(int i=0;i<unit.fruitmax;i++)
     {
             if(fruit[i].live)
             {
                     switch(fruit[i].level)
                     {
                     case 1:
                          sgreen.blt(buffer,fruit[i].pos.x,fruit[i].pos.y);
                          break;
                     case 2:
                          syellow.blt(buffer,fruit[i].pos.x,fruit[i].pos.y);
                          break;
                     case 3:
                          sred.blt(buffer,fruit[i].pos.x,fruit[i].pos.y);
                          break;
                     case 4:
                          sblue.blt(buffer,fruit[i].pos.x,fruit[i].pos.y);
                          break;
                     }
//draw_sprite(buffer,bfruit,
//fruit[i].pos.x-bfruit->w/2,fruit[i].pos.y-bfruit->h/2);
                     
             }
     }
     
     //Player
     splayer.blt(buffer,player.pos.x,player.pos.y);
     
     //train
     for(int i=0;i<4;i++)
     {
             //draw_sprite(buffer,btrain,train[i].pos.x-btrain->w/2,train[i].pos.y-btrain->h/2);
             strain.blt(buffer,train[i].pos.x,train[i].pos.y);
             if(fire[i].live)
             sfire.blt(buffer,fire[i].pos.x,fire[i].pos.y);
             //draw_sprite(buffer,bfire,fire[i].pos.x-bfire->w/2,fire[i].pos.y-bfire->h/2); //FIRE
     }
            
     //Buttons
     bstart.Draw(buffer);
     bend.Draw(buffer);
     bresume.Draw(buffer);
     //Mouse
     if(showmouse)draw_sprite(buffer,bmouse,mouse_x,mouse_y); //FIRE
    
}

void blt2(int x,int y,BITMAP *bmp,int alpha)  /*ʾ͸ͼƬ*/
{
 set_trans_blender(0,0,0,alpha);
 draw_trans_sprite(buffer,bmp,x,y);
}
void show_menu(bool b){
     if(b)
     {unit.pause=true;
     bstart.Visible(true);
     showmouse=true;
     bend.Visible(true);
     bresume.Visible(true);
     }else{
     unit.pause=false;
     bstart.Visible(false);
     bend.Visible(false);
     bresume.Visible(false);
     showmouse=false;
     }
     
}

void do_key_work()
{
     //Ϸ 
     if(key[KEY_ESC])
                     show_menu(true);
     if(key[KEY_ENTER]){
                       if(unit.pause)
                       unit.pause=0;
                       else 
                       unit.pause=1;
                       delay(500);
                       clear_keybuf();
                       }
     //                  game_initdata();
     if(key[KEY_MINUS]){
                        if(DELAY>5)DELAY-=5;
                        delay2(100);
                        clear_keybuf();
                        }
     if(key[KEY_EQUALS]){
                        if(DELAY<100)DELAY+=5;
                        delay2(100);
                        clear_keybuf();
                        }
     if(key[KEY_HOME]){
                        player.live++;
                        delay2(100);
                        clear_keybuf();
                        }
     if(key[KEY_END]){
                        player.live--;
                        delay2(100);
                        clear_keybuf();
                        }
     //Mouse
     if(bstart.Value())
     {
                       game_initdata();
                     show_menu(false);
     }
     if(bend.Value())
     {
                     unit.end=true;
                     show_menu(false);
     }
     if(bresume.Value())
     {
                        if(unit.fruitmax==0){
                                             game_load();
                                             }
                     unit.pause=false;
                     show_menu(false);
     }
     
     if(unit.pause)return;
     //
     //Player
     int keyed=0;
     if(player.fw==fwLEFT)
     {
           if(player.pos.x>IND) player.pos.x-=player.speed2;
     }else if(player.fw==fwRIGHT){
           if(player.pos.x<unit.width-IND)player.pos.x+=player.speed2;
     }else if(player.fw==fwUP){
           if(player.pos.y>IND)player.pos.y-=player.speed2;
     }else if(player.fw==fwDOWN){
           if(player.pos.y<unit.height-IND)player.pos.y+=player.speed2;
     }
     if(key[KEY_LEFT]){
                      player.fw=fwLEFT;keyed=1;
     }else if(key[KEY_RIGHT]){
                       player.fw=fwRIGHT;keyed=1;
     }else if(key[KEY_UP]){
                      player.fw=fwUP;keyed=1;
     }else if(key[KEY_DOWN]){
                       player.fw=fwDOWN;keyed=1;
     }
     
     if(keyed)
     {if(player.speed2<player.speedmax)player.speed2++;
     }else
     if(player.speed2>0)player.speed2--;
     
} 
void eat_apple()
{
     // ʯ
     int x1,y1,t;
     for(int i=0;i<unit.fruitmax;i++)
     {
             if(!fruit[i].live)continue;
             x1=fruit[i].pos.x-player.pos.x;
             y1=fruit[i].pos.y-player.pos.y;
             t=int(sqrt(x1*x1+y1*y1));
             if(t<20)//ײ
             {
                           fruit[i].live=0;
                           unit.score+=fruit[i].score;
                           play_sample(seat,255,pan,pitch,0);
                           unit.apples++;
             }
     }
}
void hit_fire()
{
     int x1,y1,t;
     for(int i=0;i<4;i++)
     {
             if(!fire[i].live)continue;
             x1=fire[i].pos.x-player.pos.x;
             y1=fire[i].pos.y-player.pos.y;
             t=int(sqrt(x1*x1+y1*y1));
             if(t<20)//ײ
             {
                           fire[i].live=0;
                           player.live--;
                           play_sample(attact,255,pan,pitch,0);
                           
             }
     }
}
void shoot(int i,int fw)
{
     if(fire[i].live)return;
     fire[i].live=-1;
     fire[i].pos.x=train[i].pos.x;
     fire[i].pos.y=train[i].pos.y;
     if(fw==1)
     {            if(fire[i].pos.y<unit.width/2)
                                                fire[i].fw=fwDOWN;
                  else 
                                                fire[i].fw=fwUP;
     }
     if(fw==0)
     {            if(fire[i].pos.x<unit.height/2)fire[i].fw=fwRIGHT;else fire[i].fw=fwLEFT;}
     fire[i].speed=train[i].speed2;
}
void move_fire()
{
     for(int i=0;i<4;i++)
     if(fire[i].live)
     {
             if(fire[i].fw==fwUP){
             if(fire[i].pos.y<16)fire[i].live=0;
             else fire[i].pos.y-=fire[i].speed;
             }
             if(fire[i].fw==fwDOWN){
             if(fire[i].pos.y>unit.height-16)fire[i].live=0;
             else fire[i].pos.y+=fire[i].speed;
             }
             if(fire[i].fw==fwLEFT){
             if(fire[i].pos.x<16)fire[i].live=0;
             else fire[i].pos.x-=fire[i].speed;
             }
             if(fire[i].fw==fwRIGHT){
             if(fire[i].pos.x>unit.width-16)fire[i].live=0;
             else fire[i].pos.x+=fire[i].speed;
             }
     }
 }
void move_train()
{
     //Train
     for(int i=0;i<4;i++)
     {
             if(train[i].fw==fwUP)
             if(train[i].pos.y<16)train[i].fw=fwDOWN;
             else train[i].pos.y-=train[i].speed;
             if(train[i].fw==fwDOWN)
             if(train[i].pos.y>unit.height-16)train[i].fw=fwUP;
             else train[i].pos.y+=train[i].speed;
             if(train[i].fw==fwLEFT)
             if(train[i].pos.x<16)train[i].fw=fwRIGHT;
             else train[i].pos.x-=train[i].speed;
             if(train[i].fw==fwRIGHT)
             if(train[i].pos.x>unit.width-16)train[i].fw=fwLEFT;
             else train[i].pos.x+=train[i].speed;
     //Train fire
             if(train[i].fw==fwUP||train[i].fw==fwDOWN)
                 if(abs(train[i].pos.y-player.pos.y)<3)
                      shoot(i,0);
             if(train[i].fw==fwLEFT||train[i].fw==fwRIGHT)
                 if(abs(train[i].pos.x-player.pos.x)<3)
                      shoot(i,1);
     }
     
}


void showwin()
{
     textout_centre_ex(buffer,font,"Great!  Go on!",unit.width/2,unit.height/2,makecol(255,255,255),-1);                 
     show_to_screen();
     delay2(1500);   
       
     if(unit.level%10==0){
     textout_centre_ex(buffer,font,"Great!  Go on!",unit.width/2,unit.height/2,makecol(255,255,255),-1);
     show_to_screen();
     delay2(1500);
     textout_centre_ex(buffer,font,"Please send your file \"save.dat\" to huang_2008@msn.com",unit.width/2,unit.height/2,makecol(255,255,255),-1);
     textout_centre_ex(buffer,font,"You will get a nice present if you do that!",unit.width/2,unit.height/2+16,makecol(255,255,255),-1);
     textout_centre_ex(buffer,font,"Maybe it is a new game that you would like very much!",unit.width/2,unit.height/2+32,makecol(255,255,255),-1);
     show_to_screen();
     delay2(500);
     clear_keybuf();
     readkey();
     }
     char c[16];
     sprintf(c,"Level %d",unit.level+1);
     textout_centre_ex(buffer,font,c,unit.width/2,unit.height/2,makecol(255,255,255),-1);
     show_to_screen();
     delay2(2000);
     clear_keybuf();
     game_next();
}
void showlost()
{
     draw_sprite(buffer,blost,unit.width/2-blost->w/2,unit.height/2-blost->h/2);
     //unit.end=true;
     show_to_screen();
     delay2(2000);
     clear_keybuf();
     readkey();
     game_initdata();
}

void iswin()
{
     bool b=false;
     for(int i=0;i<unit.fruitmax;i++)
             if(fruit[i].live)b=true;
     if(!b)
     {
          showwin();
     }
     
     if(player.live<1)
     {
          showlost();
     }
     if(unit.score>=player.maxjy){
                                 player.live++;
	                             player.maxjy+=20000;
                                 play_sample(liveup,255,pan,pitch,0);}
}
void flash()
{
     if(unit.timer%5==0)
     {sgreen.AutoStep();
     sred.AutoStep();
     syellow.AutoStep();
     sblue.AutoStep();
     splayer.Step(player.fw);
     strain.AutoStep();
     sfire.AutoStep();
     }
     bstart.Flash();
     bend.Flash();
     bresume.Flash();
}
void destory_all()
{
     //bmp
     destroy_sample(seat);
     destroy_sample(attact);
     destroy_sample(liveup);
     destroy_bitmap(bmouse);
     destroy_midi(backsound);
}
int main()
{
    allegro_init();                         /*ʼ Allegro */
    install_keyboard();                     /*ʼ*/
    install_mouse();                        /*ʼ*/
    //delay(1000);
    /*ʼ, ɹ򷵻*/
    install_sound(DIGI_AUTODETECT, DIGI_AUTODETECT, "");
     //Load Datas
     FILE *fp=fopen("setting.ini","r");
     if(fp!=NULL){
     fscanf(fp,"%d%d%d%d%d%d%d%d%d",&def_train_speed,&DELAY,&def_train_speed2,
&def_player_speed,
&def_fruit_count,
&COLOR_MODE,
&WINDOW_MODE,
&SW,
&SH);
}
     fclose(fp);
    setvideo();
	loadfile();          /*ͼƬļ */
	show_menu(true);
	//game_initdata();		/*ʼ*/
	set_window_title(unit.name);
	int R;
    srand(R);
    //Ϸѭ
    while(!unit.end)
    {
        //Ļ 
        show_to_screen();
        //
            flash();
        if(!unit.pause)
        {
            eat_apple();
            hit_fire();
            move_fire();
            move_train();
            //Ƿʤ
            iswin();
            unit.timer++;
        }
        //ͼ
        put_bmp(); 
        //ʱ
        do_key_work();
        delay(DELAY);
    } 
    game_save();
    //readkey();
    destory_all();
    allegro_exit();
    return 0;   
}
END_OF_MAIN();
//
