/*
  Name: Game Sprite Class
  Copyright: 203a.com
  Author: Huang Guan
  Date: 11-11-05 16:07
  Description: Used for Collect Diamonds
*/

#include <allegro.h>
#include <string.h>
#include<mem.h>
class Sprite{
      private:
      BITMAP *buf[5];
      //BITMAP *owner;
      int maxbmp;
      int sx,sy;
      int gi; // No.
      int giw,gih;
      PALLETE pallete;
      public:
      Sprite(){
               gi=0;
               };
      void Create(const char *file,int count,int gw,int gh)
      {
                    //buf= BITMAP*[count];
                    char path[16];
                    for(int i=0;i<count;i++)
                    {       
                            sprintf(path,"%s%d.dat",file,i);
                             buf[i]=load_bmp(path,pallete);
                             }
                    giw=gw;
                    gih=gh;
                    sx=0;
                    sy=0;
                    gi=0;
                    maxbmp=count;
      };
      void blt(BITMAP *o){
           //blit(buf[gi],o,0,0,0,0,giw,gih); 
           draw_sprite(o,buf[gi],sx,sy);
           //blit(buf[gi],o,sx,sy);
      };
      void blt(BITMAP *o,int x,int y){
           draw_sprite(o,buf[gi],x-giw/2,y-gih/2);
      };
      void AutoStep(){
           gi++;
           if(gi>=maxbmp)gi=0;
      };
      void Step(int i){
           gi=i;
      };
      ~Sprite(){
                for(int i=0;i<maxbmp;i++)
                        free(buf[i]);
                };
};
